<?php

namespace App\DataFixtures;

use App\Entity\OrganizationalUnit;
use App\Factory\OrganizationalUnitFactory;
use App\Factory\UserFactory;
use App\Model\OrganizationalUnitTypes;
use App\Model\UserGroupPermissions;
use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Persistence\ObjectManager;

class AppFixtures extends Fixture
{
    CONST ADMIN_USER = 'ogadmin';

    /**
     * @throws \Exception
     */
    public function load(ObjectManager $manager): void
    {
        UserFactory::createOne(['username' => self::ADMIN_USER, 'roles'=> [UserGroupPermissions::ROLE_SUPER_ADMIN]]);
        $rootUnit = OrganizationalUnitFactory::createOne(['name' => 'Centro de Computación', 'parent' => null, 'type' => OrganizationalUnitTypes::ORGANIZATIONAL_UNIT]);

        $roomUnit = OrganizationalUnitFactory::createOne([
            'name' => 'Aula 1',
            'parent' => $rootUnit,
            'type' => OrganizationalUnitTypes::CLASSROOMS_GROUP
        ]);

        OrganizationalUnitFactory::createOne([
            'name' => 'Aula 2',
            'parent' => $roomUnit,
            'type' => OrganizationalUnitTypes::CLASSROOM
        ]);
    }
}
